from clifinance.application.dto.selector import SelectorDTO
from clifinance.domain.expense.gateway import ExpenseGateway
from clifinance.domain.expense.model import (
    Expense,
    ExpenseAmount,
    ExpenseDate,
    ExpenseType,
)


class GetExpensesByFilter:
    def __init__(
        self,
        gateway: ExpenseGateway,
    ) -> None:
        self.__gateway = gateway

    def __call__(self, filter: SelectorDTO) -> list[Expense]:
        return self.__gateway.get_all_expenses_by_filter(
            type=ExpenseType(filter.type) if filter.type else None,
            date=ExpenseDate(filter.date) if filter.date else None,
            amount=ExpenseAmount(filter.amount) if filter.amount else None,
        )
